--modDesc firt line ---> <sourceFile filename="guiMenue\guiMenue.lua" />
--set at your mod ---> g_currentMission.guiMenue.on = true (for mouse control)(if true then gui menue ready)
--check modMenue table,search your modMenue table
--local yourModMenueTable = 0;
--if g_currentMission.guiMenue.modMenueTable ~= nil and #g_currentMission.guiMenue.modMenueTable > 0 then
--	 for a=1, #g_currentMission.guiMenue.modMenueTable do
--		if g_currentMission.guiMenue.modMenueTable[a] == tostring(modMenueName) then
--		   yourModMenueTable = a;
--		   break;
--		end 
--	 end
--end
--open GUI Menue:set optional at your mod ---> g_currentMission.guiMenue.modMenue = yourModMenueTable
--end
--player click save button
--if g_currentMission.guiMenue.on and g_currentMission.guiMenue.modMenue == yourModMenueTable and g_currentMission.guiMenue.mod[tostring(modMenueName)].save then
--	(modMenueName value 1(VehicleInspector)= guiSetGet:generateModMenue("VehicleInspector", "VehicleInspector Settings"))
-- 	optional check open page ---> g_currentMission.guiMenue.mod[tostring(modMenueName)].lastPage <--- seperate savefile
--	 save your savefile
--   g_currentMission.guiMenue.mod[tostring(modMenueName)].save = false; <--- reset set false
--   g_currentMission.guiMenue.mod[tostring(modMenueName)].tempSave = false; <---is true then saveButton red(reset set false)
--end
--buttonsTypes.........
--type0 = "hidden",
--type1 = "arrowLeft",
--type2 = "arrowLeftDouble",
--type3 = "arrowRight",
--type4 = "arrowRightDouble",
--type5 = "arrowDown",			
--type6 = "arrowDownDouble",
--type7 = "arrowUp",			
--type8 = "arrowUpDouble"
--type9 = "roundRight",
--type10 = "roundRightDouble",
--type11 = "roundLeft",
--type12 = "roundLeftDouble",
--type13 = "halfRoundRight",
--type14 = "halfRoundRightDouble",
--type15 = "halfRoundLeft",
--type16 = "halfRoundLeftDouble",
--type17 = "roundMultiple",
--type18 = "roundMultipleDouble",
--type19 = "roundButton",
--type20 = "roundButtonDouble"	
--Bsp Mod: VehicleInspector(guiMenueSettings.lua,VehicleInspector.lua)

guiMenue = {};

guiMenue.metadata = {
	interface = " FS17 1.x",
	title = " GUI Menue(Simple)",
	notes = " Erstellt ein Konfigurations Menue Hud für Mods etc.",
	author = " (by HappyLooser)",
	version = " v0.4 Beta",
	datum = " 03.01.2017",
	update = " 08.08.2017",
	web = " no",
	info = " Link Freigabe,Änderungen,Kopien Benutzung ist ohne meine Zustimmung nicht erlaubt",
	info1 = " Benutzung als GUI Menue in einem Mod (ohne Code Änderung) ist ohne Zustimmung erlaubt",
	"##Orginal Link Freigabe:"
};

guiMenue.modDir = g_currentModDirectory;
function guiMenue:loadMap(name)
	if guiMenue:getServer() then return;end;	
	guiMenue:loadScripts(guiMenue.modDir);
	if g_currentMission.guiMenue == nil then
		g_currentMission.guiMenue = {};
		g_currentMission.guiMenue.master = self;		
		g_currentMission.guiMenue.on = false;
		g_currentMission.guiMenue.downUp = {open=false,line=0};
		g_currentMission.guiMenue.overlays = {};		
		g_currentMission.guiMenue.modMenue = 1;		
		g_currentMission.guiMenue.modMenueTable = {};
		g_currentMission.guiMenue.mod = {};
		g_currentMission.guiMenue.clickAreas = {};
		guiSetGet:defaultValues(g_currentMission.guiMenue.master);
		g_currentMission.guiMenue.infoText = {txt="";size=g_currentMission.guiMenue.default.infoTextSize};
		g_currentMission.guiMenue.helpText = {txt="";posX=0;posY=0;size=g_currentMission.guiMenue.default.helpTextSize};
		g_currentMission.guiMenue.markerColorButton = {posX=0;posY=0;width=0,height=0,colorName="",overlayName=""};
	end;	
end;

function guiMenue:deleteMap()
	if not guiMenue:getMasterLoad(self) or guiMenue:getServer() then return;end;
	guiSetGet:deleteMenueImages()
end;

function guiMenue:mouseEvent(posX, posY, isDown, isUp, button)
	if not guiMenue:getMasterLoad(self) or guiMenue:getServer() or guiMenue:getFullSize(self) or guiMenue:getIngameMap() then return;end;
	guiKeyMouseEvents:setKeyMouse(g_currentMission.guiMenue.master, nil, nil, nil, nil, posX, posY, isDown, isUp, button);
end;

function guiMenue:keyEvent(unicode, sym, modifier, isDown)	
	if not guiMenue:getMasterLoad(self) or guiMenue:getServer() or guiMenue:getFullSize(self) or guiMenue:getIngameMap() then return;end;
	guiKeyMouseEvents:setKeyMouse(g_currentMission.guiMenue.master, unicode, sym, modifier, isDownKey, nil, nil, nil, nil, nil);
end;

function guiMenue:updateTick(dt)	
end;

function guiMenue:update(dt)	
end;

function guiMenue:draw()
	if not guiMenue:getMasterLoad(self) or guiMenue:getServer() or guiMenue:getFullSize(self) or guiMenue:getIngameMap() then return;end;
	if not g_currentMission.guiMenue.on then g_currentMission.guiMenue.clickAreas = {};return;end;
	guiDraw:open(g_currentMission.guiMenue.master);	
	if g_currentMission.guiMenue.markerColorButton.posX ~= 0 then
		local overlay = g_currentMission.guiMenue.overlays;
		guiSetGet:setBackgroundColor(overlay[tostring(g_currentMission.guiMenue.markerColorButton.overlayName)], guiSetGet.colors[tostring(g_currentMission.guiMenue.markerColorButton.colorName)]);
		guiSetGet:setOverlay(overlay[tostring(g_currentMission.guiMenue.markerColorButton.overlayName)], g_currentMission.guiMenue.markerColorButton.posX, g_currentMission.guiMenue.markerColorButton.posY, g_currentMission.guiMenue.markerColorButton.width, g_currentMission.guiMenue.markerColorButton.height);
		overlay[tostring(g_currentMission.guiMenue.markerColorButton.overlayName)]:render();
	end;	
	if string.len(g_currentMission.guiMenue.helpText.txt) > 0 and (g_currentMission.guiMenue.helpText.posX ~= 0 or g_currentMission.guiMenue.helpText.posY ~= 0) then
		setTextBold(true);
		setTextColor(unpack(g_currentMission.guiMenue.default.helpTextColor));
		local size = g_currentMission.guiMenue.helpText.size;
		local txtHeight = getTextHeight(size, tostring(g_currentMission.guiMenue.helpText.txt));
		local txtWidth = getTextWidth(size, tostring(g_currentMission.guiMenue.helpText.txt))
		local txtHeightLine = getTextHeight(size, tostring("----Test----"));
		if g_currentMission.guiMenue.helpText.posY+(txtHeight-txtHeightLine) > 0.99 then
			g_currentMission.guiMenue.helpText.posY = 0.99-(txtHeight);			
		end;
		if g_currentMission.guiMenue.helpText.posX+(txtWidth) > 0.99 then
			g_currentMission.guiMenue.helpText.posX = 0.99-(txtWidth);			
		end;
		guiSetGet:setOverlay(g_currentMission.guiMenue.overlays["helpGround"], g_currentMission.guiMenue.helpText.posX, g_currentMission.guiMenue.helpText.posY-0.002, txtWidth, txtHeight);			
		g_currentMission.guiMenue.overlays["helpGround"]:render();			
		renderText(g_currentMission.guiMenue.helpText.posX, g_currentMission.guiMenue.helpText.posY+(txtHeight-txtHeightLine), size, tostring(g_currentMission.guiMenue.helpText.txt));
		setTextBold(false);
	end;
	if string.len(g_currentMission.guiMenue.infoText.txt) > 0 then
		setTextBold(true);
		setTextColor(unpack(g_currentMission.guiMenue.default.infoTextColor));
		local size = g_currentMission.guiMenue.infoText.size;			
		local txtHeight = getTextHeight(size, tostring("----Test----"));
		guiSetGet:setOverlay(g_currentMission.guiMenue.overlays["infoText"], g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2), g_currentMission.guiMenue.default.posY-(g_currentMission.guiMenue.default.height)+(g_currentMission.guiMenue.default.iconHeight*3), false, false);			
		g_currentMission.guiMenue.overlays["infoText"]:render();			
		renderText(g_currentMission.guiMenue.default.posX-(g_currentMission.guiMenue.default.width/2)+(g_currentMission.guiMenue.default.iconHeight/1.5), g_currentMission.guiMenue.default.posY-(g_currentMission.guiMenue.default.height)+(g_currentMission.guiMenue.default.iconHeight*4)-txtHeight, size, tostring(g_currentMission.guiMenue.infoText.txt));
		setTextBold(false);
	end;
	--respect settings for other mods
	setTextAlignment(0);
	setTextColor(1, 1, 1, 1);
	setTextBold(false);
	--respect settings for other mods
end;
addModEventListener(guiMenue);

function guiMenue:loadScripts(modDir)	
	source(modDir.."guiMenue/guiDraw.lua");
	source(modDir.."guiMenue/guiKeyMouseEvents.lua");	
	source(modDir.."guiMenue/guiSetGet.lua");
end;

function guiMenue:mouseIsInArea(mouseX, mouseY, areaX1, areaX2, areaY1, areaY2)
	return mouseX >= areaX1 and mouseX <= areaX2 and mouseY >= areaY1 and mouseY <= areaY2;
end;

function guiMenue:getMasterLoad(self)
	if g_currentMission.guiMenue.master ~= self then return false;end;
	return true;
end;

function guiMenue:getServer()
	if (g_server ~= nil and g_client ~= nil) or (g_client ~= nil and g_server == nil) then return false;end;	
	return true;
end;

function guiMenue:getFullSize(self)
	if g_currentMission.paused or 
	g_currentMission.manualPaused or
	g_inGameMenu.isOpen or
	g_currentMission.physicsPaused then 
	if g_currentMission.missionDynamicInfo.isMultiplayer and g_currentMission.manualPaused then return false;end; --patch 1.3 bug !!
	return true;end;
	return false;
end;

function guiMenue:getIngameMap()
	if g_currentMission.ingameMap.isVisible and g_currentMission.ingameMap.state == 1 
	then return true;end;
	return false;
end;